=== debian/changelog ===
darktable (0.9.3-2ubuntu1) precise; urgency=low

  * Sync on Debian
  * Drop deprecated g_thread_init(), fixes FTBFS
    - add debian/patches/drop_g_thread_init.patch
    - add debian/patches/series
  * Mark Debian Vcs-* as XS-Debian-Vcs-*
    - update debian/control

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 05 Feb 2012 18:25:53 -0600

darktable (0.9.3-2) unstable; urgency=low

  * Bug fix: "Darktable is missing Flickr export option", thanks to Mike
    Alborn (Closes: #644517).

 -- David Bremner <bremner@debian.org>  Tue, 24 Jan 2012 17:27:06 -0400

darktable (0.9.3-1) unstable; urgency=low

  * New upstream version

 -- David Bremner <bremner@debian.org>  Sun, 13 Nov 2011 10:46:00 -0400
