=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,13 @@
 # Add files for libdarktable
 #
 FILE(GLOB SOURCE_FILES
+  "common/cache.c"
   "common/collection.c" 
   "common/colorlabels.c" 
   "common/colormatrices.c" 
   "common/colorspaces.c" 
   "common/darktable.c" 
+  "common/database.c"
   "common/exif.cc" 
   "common/film.c" 
   "common/fswatch.c" 
@@ -27,7 +29,9 @@
   "common/imageio_tiff.c" 
   "common/imageio_rawspeed.cc" 
   "common/metadata.c" 
+  "common/mipmap_cache.c"
   "common/styles.c" 
+  "common/selection.c"
   "common/tags.c" 
   "common/utility.c" 
   "common/variables.c" 
@@ -36,30 +40,33 @@
   "common/opencl.c"
   "common/dynload.c"
   "common/dlopencl.c"
+  "common/ratings.c"
   "control/control.c"  
   "control/jobs/control_jobs.c"  
   "control/jobs/develop_jobs.c"  
-  "control/jobs/film_jobs.c"
+  "control/jobs/film_jobs.c"  
   "control/jobs/image_jobs.c"
+  "control/signal.c"
   "develop/develop.c"
   "develop/imageop.c"
   "develop/pixelpipe.c"
   "develop/blend.c"
   "develop/tiling.c"
-  "dtgtk/*.c"
+  "dtgtk/button.c"
+  "dtgtk/icon.c"
+  "dtgtk/label.c"
+  "dtgtk/slider.c"
+  "dtgtk/gradientslider.c"
+  "dtgtk/tristatebutton.c"
+  "dtgtk/togglebutton.c"
+  "dtgtk/paint.c"
+  "dtgtk/resetlabel.c"
   "gui/accelerators.c"
-  "gui/background_jobs.c"
   "gui/contrast.c"  
   "gui/gtk.c"  
-  "gui/histogram.c"  
-  "gui/iop_history.c"  
-  "gui/iop_modulegroups.c"  
-  "gui/metadata.c"  
-  "gui/navigation.c"  
   "gui/preferences.c"  
   "gui/presets.c"  
   "gui/styles_dialog.c"  
-  "gui/tool_colorlabels.c"  
   "libs/lib.c"
   "views/view.c"
   )
@@ -102,16 +109,6 @@
 include_directories(${LIBXML2_INCLUDE_DIR})
 list(APPEND LIBS ${LIBXML2_LIBRARIES})
 add_definitions(${LIBXML2_DEFINITIONS})
-
-
-# Check for gconf2 / broken cmake module can't be included in the foreach() below
-if(USE_GCONF_BACKEND)
-  find_package(GConf2)
-  include_directories(${GConf2_INCLUDE_DIRS})
-  list(APPEND LIBS ${GConf2_LIBRARIES})
-  add_definitions(${GConf2_DEFINITIONS})
-endif(USE_GCONF_BACKEND)
-
 
 
 if(USE_CAMERA_SUPPORT)
@@ -176,6 +173,15 @@
 # have a small test program, to be run as root on some systems to enable the driver to run cl stuff
 add_subdirectory(cltest)
 
+if(USE_UNITY)
+  find_package(Unity)
+  if(UNITY_FOUND)
+    add_definitions(-DHAVE_UNITY)
+    include_directories(${UNITY_INCLUDE_DIRS})
+    list(APPEND LIBS ${UNITY_LIBRARIES})
+  endif(UNITY_FOUND)
+endif(USE_UNITY)
+
 # build opengl slideshow viewer?
 if(BUILD_SLIDESHOW) 
   find_package(SDL)
@@ -205,10 +211,6 @@
   add_definitions("-DHAVE_LENSFUN")
 endif(LENSFUN_FOUND)
 
-if(GCONF2_FOUND)
-  add_definitions("-DHAVE_GCONF")
-endif(GCONF2_FOUND)
-
 if(OPENEXR_FOUND)
   add_definitions("-DHAVE_OPENEXR")
 endif(OPENEXR_FOUND)
@@ -219,7 +221,7 @@
 
 
 if(GPHOTO2_FOUND)
-  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" "gui/devices.c" )
+  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" )
   add_definitions("-DHAVE_GPHOTO2")
 endif(GPHOTO2_FOUND)
 
@@ -258,11 +260,11 @@
  	set(MARCH "-mtune=generic")
 endif()
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
-set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse -g")
+set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations ${MARCH}")
 set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g -D_DEBUG")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
-set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse -g")
+set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations ${MARCH}")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -D_DEBUG")
