=== debian/changelog ===
darktable (1.0-1) experimental; urgency=low

  * New upstream release
  * Bug fix: "darktable gconf schemas cause warnings on each gconf2
    trigger call", thanks to Julien Valroff (Closes: #624763).
  * Bump standards version (no changes).

 -- David Bremner <bremner@debian.org>  Thu, 15 Mar 2012 19:14:57 -0300
